﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4.2
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim SQL1 As SQL
	Public InitialFilePath As String
	Public DBaseFilePath As String	
End Sub

'Controlla se il database esite già
Public Sub CreateSqlDatabase
	ObtainFilePath
	If File.Exists(DBaseFilePath, "dbLista.db") = False Then
		SQL1.InitializeSQLite(DBaseFilePath, "dbLista.db", True)					'imposto il nome del file "dbOfficina.db" (nome a piacere)
		CreateWorkTab
	Else
		SQL1.InitializeSQLite(DBaseFilePath, "dbLista.db", True)
	End If
End Sub

'Crea cartella che conterrà il database
Private Sub ObtainFilePath
	Dim str1 As String
	
	str1 = GetSystemProperty("user.home","")							'Preleva la folder di default dello user collegato
	
	If Not(File.IsDirectory(str1, "Ricette")) Then						'controllo se la cartella "Officina" nella directory principale esiste
		File.MakeDir(str1, "Ricette")
	End If
	
	InitialFilePath = File.Combine(str1, "Ricette")
	
	
	' DBase File Path
	If Not(File.IsDirectory(InitialFilePath, "data")) Then					'controllo se la cartella "data" nella directory principale "Officina" esiste
		File.MakeDir(InitialFilePath, "data")
		DBaseFilePath = File.Combine(InitialFilePath, "data")
	Else
		DBaseFilePath = File.Combine(InitialFilePath, "data")		
	End If
End Sub

' Crea la tabella
Private Sub CreateWorkTab
	Dim M As Map
	
	M.Initialize
	M.Put("Id", DBUtils.DB_INTEGER)			' + auto incrementa
	M.Put("Nome", DBUtils.DB_TEXT)
	M.Put("Tipo", DBUtils.DB_TEXT)
	M.Put("Difficolta", DBUtils.DB_TEXT)
	M.Put("Dosi", DBUtils.DB_INTEGER)
	M.Put("Data", DBUtils.DB_TEXT)
	M.Put("Voce1", DBUtils.DB_TEXT)
	M.Put("Voce2", DBUtils.DB_TEXT)
	M.Put("Voce3", DBUtils.DB_TEXT)
	M.Put("Voce4", DBUtils.DB_TEXT)
	M.Put("Voce5", DBUtils.DB_TEXT)
	M.Put("Voce6", DBUtils.DB_TEXT)
	M.Put("Voce7", DBUtils.DB_TEXT)
	M.Put("Voce8", DBUtils.DB_TEXT)
	M.Put("Voce9", DBUtils.DB_TEXT)
	
	
	DBUtils.CreateTable(SQL1, "dbTabLista", M, "Id")
End Sub